<?php

use XoopsModules\Tadtools\Utility;

//其他自訂的共同的函數

//檢查user是否具有審核權限
function kw_device_isCheck($uid)
{
    global $xoopsUser, $xoopsDB, $iskwDeviceAdmin;

    if ($xoopsUser) {
        if ($iskwDeviceAdmin) {
            return true;
            exit;
        }
        $sql = "select `config_uid` from `" . $xoopsDB->prefix("kw_device_config") . "` where `config_uid`='" . $uid . "' and `config_isenable` ='1' ";

        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        list($uid) = $xoopsDB->fetchRow($result);
        if ($uid) {
            return true;
            exit;
        }
    }
    return false;
}

//檢查user是否具有借用權限
// function kw_device_isBook($mode = "kw_device_book_group")
// {
//     global $xoopsUser, $xoopsModuleConfig, $iskwDeviceAdmin;

//     if ($xoopsUser) {
//         if ($iskwDeviceAdmin) {
//             return true;
//             exit;
//         }
//         $my_groups = $xoopsUser->groups();
//         $book_groups = $xoopsModuleConfig[$mode];
//         //die(var_export($mygroups)."==".var_export($book_groups));
//         foreach ($my_groups as $key => $group) {
//             if (in_array($group, $book_groups)) {
//                 return true;
//             }
//         }
//     }
//     return false;
// }

//以ID取得單筆資料
/**
 * @param $dbName
 * @param $ID
 * @return $data
 */
function kw_device_get_data($dbName, $dbName_ID = '', $name = '', $value = '')
{
    global $xoopsDB;

    if (empty($dbName)) {
        redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWDEVICE_ERROR);
        return;
    }

    if (!empty($dbName_ID)) //用id取得資料
    {
        $sql = 'select * from `' . $xoopsDB->prefix('kw_device_' . $dbName) . "`  where `{$dbName}_id` = '{$dbName_ID}'";
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        $data = $xoopsDB->fetchArray($result);
    } else if (!empty($name) && !empty($value)) {
        $sql = 'select * from `' . $xoopsDB->prefix('kw_device_' . $dbName) . "`  where `{$name}` = '{$value}'";
        $data = [];
        $i = 1;
        while (false !== ($all = $xoopsDB->fetchArray($result))) {
            $data[$i] = $all;
            $i++;
        }
    } else //取得多筆資料
    {
        $sql = 'select * from `' . $xoopsDB->prefix('kw_device_' . $dbName) . "` ";
        $data = [];
        $i = 1;
        while (false !== ($all = $xoopsDB->fetchArray($result))) {
            $data[$all[$dbName . '_id']] = $all;
            $i++;
        }
    }
    return $data;
}

function uid_check($uid)
{
    global $xoopsDB;
    $sql = 'select `config_uid` from `' . $xoopsDB->prefix('kw_device_config') . "` where config_uid=`{$uid}`";
    $result = $xoopsDB->query($sql);
    list($Uid) = $xoopsDB->fetchRow($result);
    if ($Uid) {
        return true;
    } else {
        return false;
    }

}

//取得所有table的id和title
function kw_device_get_allTitle($dbName)
{
    global $xoopsDB;

    if (empty($dbName)) {
        redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWDEVICE_ERROR);
        return;
    }
    if ($dbName == 'config') {
        $sql = "select `{$dbName}_uid`, `{$dbName}_title` from `" . $xoopsDB->prefix('kw_device_' . $dbName) . "` where  `{$dbName}_isenable`='1' order by `{$dbName}_sort`";
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        $data = [];
        while (list($Uid, $Title) = $xoopsDB->fetchRow($result)) {
            $data[$Uid] = $Title;
        }
    } else {
        $sql = "select `{$dbName}_id`, `{$dbName}_title` from `" . $xoopsDB->prefix('kw_device_' . $dbName) . "` where  `{$dbName}_isenable`='1' order by `{$dbName}_sort`";
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        $data = [];
        while (list($Id, $Title) = $xoopsDB->fetchRow($result)) {
            $data[$Id] = $Title;
        }
    }
    return $data;
}

//取得審核者uid
function kw_device_get_config_uid($config_id = '')
{
    global $xoopsDB;

    if (!empty($config_id)) {
        $sql = "select  `config_uid` from `" . $xoopsDB->prefix('kw_device_config') . "` where  `config_id` = '" . $config_id . "'  and  `config_isenable`='1' ";
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        list($uid) = $xoopsDB->fetchRow($result);
        $data = $uid;
    } else {
        $sql = "select `config_id`, `config_uid` from `" . $xoopsDB->prefix('kw_device_config') . "` where  `config_isenable`='1' ";
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        $data = [];
        while (list($Id, $uid) = $xoopsDB->fetchRow($result)) {
            $data[$Id] = $uid;
        }
    }

    return $data;
}

//取得審核者姓名
// function kw_device_get_check($book_id)
// {
//     global $xoopsDB, $xoopsUser;
//     if (empty($book_id)) {
//         redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWDEVICE_ERROR);
//         return;
//     }
//     $sql = 'select `check_id`, `check_uid` from `' . $xoopsDB->prefix('kw_device_check') . "` where `book_id`='{$book_id}' and `check_isenable`='1' order by `check_sort`";
//     $result = $xoopsDB->query($sql) or Utility::web_error($sql);
//     $check = [];
//     while (list($check_id, $check_uid) = $xoopsDB->fetchRow($result)) {
//         $check_name = $xoopsUser->name($check_uid);
//         $check[$check_id] = $check_name;
//     }
//     return $check;
// }
//get client ip

/**
 * @return mixed
 */
function kw_device_get_ip()
{
    $ip = '';
    if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
        $ip = $_SERVER['HTTP_CLIENT_IP'];
    }
    if (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
        $ips = explode(', ', $_SERVER['HTTP_X_FORWARDED_FOR']);
        if ($ip) {
            array_unshift($ips, $ip);
            $ip = false;
        }
        foreach ($ips as $i => $iValue) {
            if (!preg_match("#^(10|172\.16|192\.168)\.#i", $ips[$i])) {
                $ip = $iValue;
                break;
            }
        }
    }
    return ($ip ?: $_SERVER['REMOTE_ADDR']);
}

//get client ip
/**
 * @param $qtd
 * @return mixed
 */
function kw_device_get_key($length = 5)
{
    $Characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $QuantidadeCharacters = strlen($Characters);
    $QuantidadeCharacters--;
    $Hash = null;
    for ($x = 1; $x <= $length; $x++) {
        $Posicao = rand(0, $QuantidadeCharacters);
        $Hash .= substr($Characters, $Posicao, 1);
    }
    return $Hash;
}

//取得日期
function kw_device_get_semester($limit) //$limit = semester,year,dcyear
{
    //semester and year
    $arr_time = getdate();
    // $this_week = $arr_time['wday'];

    if ($limit == 'year') {
    //學年為單位
        if ($arr_time['mon'] >= 1 && $arr_time['mon'] <= 7) {
            // 2-7 (第二學期)
            $this_year = $arr_time['year'] - 1912;
            $semester = [
                'year' => $this_year,
                'this_year' => $this_year,
                // 'this_dcyear' => $this_year + 1911,
                // 'this_semester' => $this_semester,
                'start_date' => $this_year . '-08-01',
                'end_date' => $this_year + 1 . '-07-31',
                'start_date_dc' => $this_year + 1911 . '-08-01',
                'end_date_dc' => $this_year + 1912 . '-07-31',
            ];
        } elseif ($arr_time['mon'] >= 8 && $arr_time['mon'] <= 12) {
            //8-12 (第一學期)
            $this_year = $arr_time['year'] - 1911;
            $semester = [
                'year' => $this_year,
                'this_year' => $this_year,
                // 'this_dcyear' => $this_year + 1911,
                // 'this_semester' => $this_semester,
                'start_date' => $this_year . '-08-01',
                'end_date' => $this_year + 1 . '-07-31',
                'start_date_dc' => $this_year + 1911 . '-08-01',
                'end_date_dc' => $this_year + 1912 . '-07-31',
            ];
        }
    } else if ($limit == 'dcyear') {
        //年度為單位
        if ($arr_time['mon'] >= 1 && $arr_time['mon'] <= 12) {
            // 1-12
            $this_year = $arr_time['year'] - 1911;
            $semester = [
                'year' => $this_year,
                'this_year' => $this_year,
                // 'this_dcyear' => $this_year + 1911,
                // 'this_semester' => $this_semester,
                'start_date' => $this_year . '-01-01',
                'end_date' => $this_year . '-12-31',
                'start_date_dc' => $this_year + 1911 . '-01-01',
                'end_date_dc' => $this_year + 1911 . '-12-31',
            ];
        }
    } else {
    //學期為單位
        if ($arr_time['mon'] >= 2 && $arr_time['mon'] <= 7) {
            // 2-7 (第二學期)
            $this_semester = '02';
            $this_year = $arr_time['year'] - 1912;
            $semester = [
                'year' => $this_year . $this_semester,
                'this_year' => $this_year,
                // 'this_dcyear' => $this_year + 1911,
                'this_semester' => $this_semester,
                'start_date' => $this_year + 1 . '-02-01',
                'end_date' => $this_year + 1 . '-07-31',
                'start_date_dc' => $this_year + 1912 . '-02-01',
                'end_date_dc' => $this_year + 1912 . '-07-31',
            ];
        } elseif ($arr_time['mon'] >= 8 && $arr_time['mon'] <= 12) {
            //8-12 (第一學期)
            $this_semester = '01';
            $this_year = $arr_time['year'] - 1911;
            $semester = [
                'year' => $this_year . $this_semester,
                'this_year' => $this_year,
                // 'this_dcyear' => $this_year + 1911,
                'this_semester' => $this_semester,
                'start_date' => $this_year . '-08-01',
                'end_date' => $this_year + 1 . '-01-31',
                'start_date_dc' => $this_year + 1911 . '-08-01',
                'end_date_dc' => $this_year + 1912 . '-01-31',
            ];
        } elseif ($arr_time['mon'] == 1) {
            //01 (第一學期)
            $this_semester = '01';
            $this_year = $arr_time['year'] - 1912;
            $semester = [
                'year' => $this_year . $this_semester,
                'this_year' => $this_year,
                // 'this_dcyear' => $this_year + 1911,
                'this_semester' => $this_semester,
                'start_date' => $this_year . '-08-01',
                'end_date' => $this_year + 1 . '-01-31',
                'start_date_dc' => $this_year + 1911 . '-08-01',
                'end_date_dc' => $this_year + 1912 . '-01-31',
            ];
        }
    }

    return $semester;
}

function kw_device_chk_time($start_date, $end_date, $mode)
{
    global $xoopsModuleConfig;

    $today = Date('Y-m-d');
    $limit_day = Date('Y-m-d', strtotime(' 7 day', strtotime($start_date)));
    $limit_week = Date('Y-m-d', strtotime(' 31 day', strtotime($start_date)));
    $limit_semester = Date('Y-m-d', strtotime(' 2 year', strtotime($start_date)));

    $semester = kw_device_get_semester($xoopsModuleConfig['school_limit']);

    if ($mode == 'day') {
        //短期借用 最長可借一星期
        if ($start_date < $semester['start_date_dc'] || $end_date > $semester['end_date_dc'] || $start_date > $end_date || $end_date > $limit_day || $start_date < $today) {
            return false;
        } else {
            return true;
        }

    } else if ($mode == 'week') {
        //中期借用 最長借1個月
        if ($start_date < $semester['start_date_dc'] || $end_date > $semester['end_date_dc'] || $start_date > $end_date || $end_date > $limit_week || $start_date < $today) {
            return false;
        } else {
            return true;
        }

    } else if ($mode == 'month') {
        //長期借用 最長借1學期
        if ($start_date < $semester['start_date_dc'] || $end_date > $semester['end_date_dc'] || $start_date > $end_date) {
            return false;
        } else {
            return true;
        }

    } else {
        //長期借用 最長借1學期
        if ($start_date < $semester['start_date_dc'] || $end_date > $semester['end_date_dc'] || $start_date > $end_date || $end_date > $limit_semester || $start_date < $today) {
            return false;
        } else {
            return true;
        }

    }
}
//檢查刪除相依性資訊 1.刪除設備時需要檢查 2.刪除預約時需要檢查 3.刪除設備類型、地點、審核者時需要檢查
//刪除cate,config,place時 check equ table
//刪除equ時，check book table
//刪除book時，check check table
function kw_device_delete_check($type, $Id, $dbname)
{
    global $xoopsDB;

    if (empty($type) or !isset($Id)) {
        redirect_header($_SERVER['PHP_SELF'], 3, _MD_KWDEVICE_ERROR);
        return;
    } else {
        if ($type == 'config') {
            $sql = 'select count(*) from `' . $xoopsDB->prefix('kw_device_' . $dbname) . "`  where `config_uid` = '{$Id}'";
        } else {
            $sql = 'select count(*) from `' . $xoopsDB->prefix('kw_device_' . $dbname) . "`  where `{$type}_id` = '{$Id}'";
        }

        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        list($count) = $xoopsDB->fetchRow($result);
    }
    return $count;
}

//更新啟用或停用
function kw_device_update_isenable($dbName, $Id, $isenable)
{
    global $xoopsDB, $kw_device_uid, $iskwDeviceAdmin, $iskwDeviceCheck;
    //檢查權限
    if (!$iskwDeviceAdmin && !$iskwDeviceCheck && !$kw_device_uid) {
        redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWDEVICE_FORBBIDEN);
        return;
    }
    // $myts = \MyTextSanitizer::getInstance();
    $arr = kw_device_get_data($dbName, $Id);
    if ($dbName == 'book') {
        $ischecked = $arr['book_ischecked'];
        $isdeny = $arr['book_isdeny'];
    }
    if ($ischecked != 0 || $isdeny != 0) //檢查狀態可行性
    {
        redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWDEVICE_FORBBIDEN);
        return;
    }

    $sql = 'update `' . $xoopsDB->prefix('kw_device_' . $dbName) . "` set
    `{$dbName}_isenable` = '{$isenable}' where `{$dbName}_id` = '$Id'";
    $xoopsDB->queryF($sql) or Utility::web_error($sql);
    return $Id;
}

//取得排序最大值
function kw_device_max_sort($type)
{
    global $xoopsDB;
    $sql = "select max(`{$type}_sort`) from `" . $xoopsDB->prefix('kw_device_' . $type) . '`';
    $result = $xoopsDB->query($sql) or Utility::web_error($sql);
    list($sort) = $xoopsDB->fetchRow($result);

    return ++$sort;
}

//取得排序值
function kw_device_get_sort($dbname, $id)
{
    global $xoopsDB, $xoopsUser;
    if (empty($dbname) || empty($id)) {
        redirect_header("{$_SERVER['PHP_SELF']}", 3, _MD_KWDEVICE_ERROR);
        return;
    }
    $sql = "select `" . $dbname . "_sort` from `" . $xoopsDB->prefix('kw_device_' . $dbName) . "` where  `" . $dbname . "_id`='{$id}' ";
    $result = $xoopsDB->query($sql) or Utility::web_error($sql);
    list($sort) = $xoopsDB->fetchRow($result);

    return $sort;
}

//以id取得所有資料
function kw_device_get_config($type, $id)
{
    global $xoopsDB;

    // $type_id = $type . '_id';
    $sql = 'select * from `' . $xoopsDB->prefix('kw_device_' . $type) . '`
    where `' . $type . "_id` = '{$id}'";

    $result = $xoopsDB->query($sql) or Utility::web_error($sql);
    $data = $xoopsDB->fetchArray($result);

    return $data;
}

//以id取得名稱
function kw_device_get_config_title($type, $id)
{
    global $xoopsDB;

    // $type_id = $type . '_id';
    if ($type == 'config') {
        $sql = "select `config_title` from `" . $xoopsDB->prefix('kw_device_' . $type) . '`
        where `' . $type . "_uid` = '{$id}'";
    } else {
        $sql = "select `" . $type . "_title` from `" . $xoopsDB->prefix('kw_device_' . $type) . '`
        where `' . $type . "_id` = '{$id}'";
    }

    $result = $xoopsDB->query($sql) or Utility::web_error($sql);
    list($data) = $xoopsDB->fetchRow($result);

    return $data;
}

function SendEmail($uid = '', $title = '', $content = '', $headers = '')
{
    global $xoopsMailer, $xoopsConfig, $xoopsDB, $xoopsModuleConfig, $xoopsModule;
    if (empty($uid)) {
        return;
    }

    // $memberHandler = xoops_getHandler('member');
    // $user           = $memberHandler->getUser($uid);
    // $email          = $user->email();
    $msg = "";
    $sql = 'select email from `' . $xoopsDB->prefix('users') . "` where uid='{$uid}'";
    $result = $xoopsDB->query($sql) or Utility::web_error($sql, __FILE__, __LINE__);
    list($email) = $xoopsDB->fetchRow($result);

    $xoopsMailer = &getMailer();
    $xoopsMailer->multimailer->ContentType = 'text/html';
    $xoopsMailer->addHeaders('MIME-Version: 1.0');

    $msg .= ($xoopsMailer->sendMail($email, $title, $content, $headers)) ? sprintf(_MD_KWDEVICE_MAIL_OK, $title, $email) : sprintf(_MD_KWDEVICE_MAIL_FAIL, $title, $email);

    return $msg;
}

//更新借用數量根據是否將設備借出去
function kw_device_check_booked_num($equ_id)
{
    global $xoopsDB;

    $semester = kw_device_get_semester($xoopsModuleConfig['school_limit']);
    $year = $semester['year'];
    $booked_num = 0;
    $sql = 'select `book_number` from `' . $xoopsDB->prefix('kw_device_book') . "` where `equ_id` = '{$equ_id}' and `book_year` = '{$year}' and `book_isdeny`<>'1' and `book_isreturn`<>'1' ";
    $result = $xoopsDB->query($sql) or Utility::web_error($sql);
    // list($count) = $xoopsDB->fetchRow($result);
    while (false !== (list($count) = $xoopsDB->fetchRow($result))) {
        $booked_num += $count;
    }
    return $booked_num;

}

//更新設備數量
function kw_device_equ_get_field($field, $equ_id)
{
    global $xoopsDB;

    $sql = "select `{$field}` from `" . $xoopsDB->prefix('kw_device_equ') . "`  where `equ_id` = '{$equ_id}' ";
    $result = $xoopsDB->query($sql) or Utility::web_error($sql);
    list($value) = $xoopsDB->fetchRow($result);
    return $value;
}

function kw_device_equ_update_field($field_title, $field_value, $equ_id)
{
    global $xoopsDB;

    $update_sql = "UPDATE `" . $xoopsDB->prefix('kw_device_equ') . "` SET `{$field_title}` ='{$field_value}'  where `equ_id`='{$equ_id}'";
    $xoopsDB->queryF($update_sql) or Utility::web_error($update_sql);

}



 //匯入設備
 /**
 * @param  $dqu_id
 */
function kw_device_equ_import(){
    global $xoopsDB,$xoopsUser,$iskwDeviceAdmin ;
    // 檢查權限
    if (!$iskwDeviceAdmin) {
        die( json_encode(['status' => 'error', 'message' => '錯誤!沒有權限!'],JSON_UNESCAPED_UNICODE));
    }
    
    // 檢查檔案是否上傳成功
    if ($_FILES['file']['error'] === UPLOAD_ERR_OK) {
       
        // 暫存檔來源
        $size = $_FILES['file']['size'];
        $file = $_FILES['file']['tmp_name'];
        $filename = $_FILES['file']['name'];
        
        
        // 副檔名檢查
        $ext = pathinfo($filename, PATHINFO_EXTENSION);
        if ($ext != 'CSV' && $ext != 'csv' ) {
            die( json_encode(['status' => 'error', 'message' => '檔案格式錯，不是excel(請留意大小寫)!'],JSON_UNESCAPED_UNICODE));
        }
        $newname = date('YmdHis');
        $dest = XOOPS_UPLOAD_PATH ."/kw_device/{$newname}.{$ext}";
        
        // 將檔案移至指定位置
        if (!move_uploaded_file($file, $dest)) {
            die( json_encode(['status' => 'error', 'message' => '移動檔案錯誤!'],JSON_UNESCAPED_UNICODE));
        }
    }
    // $ip = get_ip();
    $uid = $xoopsUser->uid();
    $all_config_arr = kw_device_get_allTitle('config');
    $all_cate_arr = kw_device_get_allTitle('cate');
    $all_place_arr = kw_device_get_allTitle('place');
    // print_r($all_config_arr);
    
    //以下是匯入資料
    if (($handle = fopen($dest, "r")) !== false) {
        $error=0;
        $i = 0;
        $line_list=[];
        while (($data = fgetcsv($handle)) !== false) { //讀取一行
            $i++;
            $num = count($data); 
            // print_r($data);
            if($num != 9 ) die( json_encode(['status' => 'error', 'message' => '錯誤!資料欄位錯誤!'],JSON_UNESCAPED_UNICODE)); 
            if ($i == 1) continue; //標題不處理
            
            //處理資料問題
            foreach ($data as $key => $value) {
                if(empty($value)) die( json_encode(['status' => 'error', 'message' => '錯誤!資料有空白!'],JSON_UNESCAPED_UNICODE)); 
                $value = trim($value);
                $data[$key] =  $value;
                if($key==2){
                    $cate_id = array_search($value, $all_cate_arr);
                    $error += empty($cate_id) ? 1: 0; 
                }else if($key==3){
                    $place_id = array_search($value, $all_place_arr);
                    $error += empty($place_id) ? 1: 0;
                }else if($key==4){
                    $config_uid = array_search($value, $all_config_arr);
                    $error += empty($config_uid)? 1: 0;
                }
            }

            //checking data exited
            $sql = "SELECT count(*),`equ_id` FROM `{$xoopsDB->prefix('kw_device_equ')}` WHERE  `equ_code`= '{$data[0]}' ";
            $result = $xoopsDB->query($sql) or Utility::web_error($sql);
            list($rows, $equ_id) = $xoopsDB->fetchRow($result);
           
            // die(print_r($data));
            
            if($rows > 0 ){ //update
                $sql = "UPDATE `{$xoopsDB->prefix('kw_device_equ')}` SET
                `equ_code`='{$data[0]}',
                `equ_year`= '{$data[1]}',
                `cate_id`= '{$cate_id}',
                `place_id`= '{$place_id}',
                `config_uid`= '{$config_uid}',
                `equ_title`= '{$data[5]}',
                `equ_note`= '{$data[6]}',
                `equ_number` = '{$data[7]}',
                `equ_date` = NOW(),
                `equ_sort`=  '{$data[8]}' 
                WHERE `equ_id` = '{$equ_id}'";
    
                $xoopsDB->query($sql)  or $iskwContestAdmin ? Utility::web_error($sql): '資料庫錯誤，請洽管理員!';
                
            }else{// 插入資料到資料表
                $sql="INSERT INTO `{$xoopsDB->prefix('kw_device_equ')}` (
                    `equ_code`, `equ_year`, `cate_id`, `place_id`, `config_uid`, `equ_title`, `equ_note`, `equ_number`, `equ_date`, `equ_sort` ) VALUE                
                    ( '{$data[0]}',  '{$data[1]}', '{$cate_id}','{$place_id}', '{$config_uid}','{$data[5]}', '{$data[6]}', '{$data[7]}', now(), '{$data[8]}' )";

                $xoopsDB->query($sql) ? $sid = $xoopsDB->getInsertId() : ($iskwContestAdmin ? Utility::web_error($sql): '資料庫錯誤，請洽管理員!');
            }
            // die($sql);
        }

        fclose($handle); // 關閉檔案
        die( json_encode(['status' => 'success', 'message' => "匯入設備成功!有{$error}欄位資料錯誤，請自行修正!"],JSON_UNESCAPED_UNICODE));
    } else {
        die( json_encode(['status' => 'error', 'message' => '無法開啟CSV檔案!'],JSON_UNESCAPED_UNICODE));
       
    }

}