<div class="row">
    <div class="col-md-6">
        <h2><{$smarty.const._MD_KWDEVICE_EQU_LIST}></h2>
    </div>
    <div class="col-sm-2" style="padding-top: 10px;">
        <a href="index.php?op=kw_device_equ_form" class="btn btn-primary btn-block" ><i class="fa fa-plus" aria-hidden="true"></i>
            <{$smarty.const._MD_KWDEVICE_ADD_EQU}></a>
    </div>
    <div class="col-sm-2" style="padding-top: 10px;">
        <button class="btn btn-info btn-block" id="btnShowModal" ><i class="fa fa-plus" aria-hidden="true"></i>
            <{$smarty.const._MD_KWDEVICE_IMPORT_EQU}>
        </button>
    </div>
    <div class="col-sm-2" style="padding-top: 10px;">
        <a href="admin.php?op=kw_device_check_list&review=all" class="btn btn-danger btn-block" ><i class="fa fa-chart-column" aria-hidden="true"></i>
            <{$smarty.const._MD_KWDEVICE_EQU_CHECK}></a>
    </div>
    <div class="col-md-12">

        <{if $all_equ_content|default:false}>
            <script type="text/javascript">
                $(document).ready(function(){
                    $("#kw_device_equ_sort").sortable({ opacity: 0.6, cursor: "move", update: function() {
                        var order = $(this).sortable("serialize");
                        $.post("<{$xoops_url|default:''}>/modules/kw_device/save_sort.php", order + "&op=update_kw_device_equ_sort", function(theResponse){
                        $("#kw_device_equ_save_msg").html(theResponse);
                        });
                    }
                    });
                });
            </script>
            <div id="kw_device_equ_save_msg"></div>
            <ul class="list-group" id="kw_device_equ_sort">
                <{foreach from=$all_equ_content item=data}>
                    <li id="equli_<{$data.equ_id}>" class="list-group-item">
                        (<{$data.equ_sort}>)<{$data.equ_title}>
                            <img src="<{$xoops_url|default:''}>/modules/tadtools/treeTable/images/updown_s.png" style="cursor: s-resize;margin:0px 4px;" alt="<{$smarty.const._TAD_SORTABLE}>" title="<{$smarty.const._TAD_SORTABLE}>">
                            <a href="javascript:delete_equ_func(<{$data.equ_id}>);" class="btn btn-sm btn-danger"><{$smarty.const._TAD_DEL}></a>
                            <a href="index.php?op=kw_device_equ_form&equ_id=<{$data.equ_id}>" class="btn btn-sm btn-warning"><{$smarty.const._TAD_EDIT}>                            </a>
                            <a href="config.php?op=kw_device_config_isenable&type=equ&isenable=<{if $data.equ_isenable==1}>0<{else}>1<{/if}>&id=<{$data.equ_id}>" data-toggle="tooltip" data-placement="top" title="<{$smarty.const._MD_KWDEVICE_CLICK_TO}>  <{if $data.equ_isenable==1}><{$smarty.const._MD_KWDEVICE_UNABLE}><{else}><{$smarty.const._MD_KWDEVICE_ENABLE}><{/if}>">
                                <{$data.equ_isenable_pic}>
                            </a>
                    </li>
                <{/foreach}>
            </ul>
        <{/if}>
    </div>
</div>



<!-- Modal -->
<div class="modal fade" id="importModal" tabindex="-1" aria-labelledby="importModalLabel" aria-hidden="true">
    <div class="modal-dialog">
    <div class="modal-content">
        <!-- Modal 標頭 -->
        <div class="modal-header">
            <h5 class="modal-title" id="importModalLabel"></h5>
            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
        </div>
        <!-- Modal 內容 -->
        <div class="modal-body">
            <form id="importForm" enctype="multipart/form-data">
                <div class="mb-3">
                <label for="excelFile" class="form-label">上傳CSV檔案</label>
                <input type="file" class="form-control" id="excelFile" name="file" accept=".csv" required>
                <input type="hidden" name="op" value="kw_device_equ_import">
                </div>
            </form>
            <button type="button" class="btn btn-warning" id="btnDownloadExample">
                <{$smarty.const._MD_KWDEVICE_IMPORT_FILE}>
            </button>
        </div>
        <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">關閉</button>
            <button type="button" class="btn btn-primary" id="btnImport">匯入</button>
        </div>
    </div>
    </div>
</div>

<script src="assets/js/sweetalert2.all.min.js"></script>
<script type="text/javascript">
    $(document).ready(function() {
    
        $('#btnShowModal').on('click', function() {
        
            var clubYear = $(this).data('club');
            var clubId = $(this).data('id');  
            
            $('#importModalLabel').text("匯入"+clubYear+"所有社團資料");
            $('#club_id').val(clubId);
            $('#club_year').val(clubYear);
            $('#importModal').modal('show');
          });
    
        $('#btnDownloadExample').on('click', function(e) {
            e.preventDefault();
            
            var downloadUrl = 'assets/kw_device_example.csv';
            var fileName = 'kw_device_example.csv';
            
            var link = document.createElement('a');
            link.href = downloadUrl;
            link.download = fileName;
            
            document.body.appendChild(link);
            link.click();
            document.body.removeChild(link);
        });
    
        $('#btnImport').on('click', function() {
              var formData = new FormData($('#importForm')[0]);
              
              $.ajax({
                url: 'config.php',   
                type: 'POST',
                data: formData,
                dataType: 'json',        
                contentType: false,       
                processData: false,        
                success: function(response) {
                    console.log('Response:', response); // 檢查回應
                    Swal.fire({
                        icon: response.status,
                        title: '上傳結果',
                        text: response.message,
                        confirmButtonText: '確定'
                      }).then(function() {
                        location.reload();
                      });
    
                },
                error: function(xhr, status, error) {
                    console.error(error);
                    Swal.fire({
                        icon: 'error',
                        title: '發生錯誤',
                        text: '匯入發生錯誤，請稍候再試。',
                        confirmButtonText: '確定'
                    });
                }
              });
        });
        
       
    });
</script>